// -*- C++ -*- generated by wxGlade 0.4 on Wed Apr 19 09:12:48 2006

/********************************

(c)2006 E.J Boks, Hogeschool van Arnhem en Nijmegen
Demonstratieprogramma voor FIR implementatie met Matlab filter coefficienten

********************************/ 

#include <strings.h>

#include "algdef.h"

#include "fir.h"
#include "fircoeff2.h"

typedef enum
{
    startKnopID=0,
    schoonKnopID,
    eindeKnopID,
    signaalKeuzeID,
    signaalAmplitudeID,
    signaalFreqKeuzeID
} knoppenIDs;




Grafiek::Grafiek(wxWindow* parent, int id, const wxString& title, const wxPoint& pos, const wxSize& size, long style):
    wxFrame(parent, id, title, pos, size, wxDEFAULT_FRAME_STYLE)
{
    // begin wxGlade: Grafiek::Grafiek
    const wxString signaalKeuzeRadioBox_choices[] = {
        wxT("cosinus"),
        wxT("blokgolf"),
        wxT("impulsfunktie"),
        wxT("stapfunktie")
    };
    signaalKeuzeRadioBox = new wxRadioBox(this, signaalKeuzeID, wxT("Signaal"), wxDefaultPosition, wxDefaultSize, 4, signaalKeuzeRadioBox_choices, 0, wxRA_SPECIFY_ROWS);
    amplitudeLabel = new wxStaticText(this, -1, wxT("Signaalamplitude"));
    amplitudeSpin = new wxSpinCtrl(this, signaalAmplitudeID, wxT("20000"), wxDefaultPosition, wxDefaultSize, wxSP_ARROW_KEYS, 0, 32768);
    sigFreqLabel = new wxStaticText(this, -1, wxT("Signaalfrequentie"));
    const wxString signaalFreqKeuze_choices[] = {
        wxT("DC"),
        wxT("0,05*PI"),
        wxT("0,1*PI"),
        wxT("0,2*PI"),
        wxT("0,4*PI"),
        wxT("0,6*PI"),
        wxT("0,8*PI"),
        wxT("0,9*PI"),
        wxT(""),
        wxT("")
    };
    signaalFreqKeuze = new wxChoice(this, signaalFreqKeuzeID, wxDefaultPosition, wxDefaultSize, 10, signaalFreqKeuze_choices, 0);
    startKnop = new wxToggleButton(this, startKnopID, wxT("Teken"));
    eindeKnop = new wxButton(this, eindeKnopID, wxT("Einde"));
    kopTekstLabel = new wxStaticText(this, -1, wxT("Implementatie van een signed 16 bit integer FIR filter"));
    grafiekPaneel = new GrafiekPaneel(this, -1);

    set_properties();
    do_layout();
    // end wxGlade

    start = False;
    
}


BEGIN_EVENT_TABLE(Grafiek, wxFrame)
    // begin wxGlade: Grafiek::event_table
    EVT_RADIOBOX(signaalKeuzeID, Grafiek::signaalKeuzeHandler)
    EVT_SPINCTRL(signaalAmplitudeID, Grafiek::signaalAmplitudeHandler)
    EVT_CHOICE(signaalFreqKeuzeID, Grafiek::signaalFreqHandler)
    EVT_TOGGLEBUTTON(startKnopID, Grafiek::startStopHandler)
    EVT_BUTTON(eindeKnopID, Grafiek::eindeHandler)
    // end wxGlade

    EVT_UPDATE_UI(eindeKnopID, Grafiek::eindeUpdateHandler)
    EVT_UPDATE_UI(signaalKeuzeID, Grafiek::eindeUpdateHandler)
    EVT_UPDATE_UI(signaalAmplitudeID, Grafiek::eindeUpdateHandler)
    EVT_UPDATE_UI(signaalFreqKeuzeID, Grafiek::eindeUpdateHandler)


END_EVENT_TABLE();


void Grafiek::eindeUpdateHandler(wxUpdateUIEvent &event)
{
    event.Enable(start==False);
}


void Grafiek::startStopHandler(wxCommandEvent &event)
{

    switch(start = startKnop->GetValue())
    {
    case False:
	grafiekPaneel->maakSchoon();
	startKnop->SetLabel(wxT("Teken"));
	break;
	
    case True:
	bouwSignaal();
	filterSignaal();
	
	if (Ok != grafiekPaneel->kopieerSignaal(signaal,sigGefilterd))
	    wxLogDebug(wxT("(startStopHandler) kon data niet inladen."));
	else
	{
	    grafiekPaneel->Refresh();    
	    startKnop->SetLabel(wxT("Stop"));
	}
	break;
	
    default:
	break;
    }
    

}


void Grafiek::eindeHandler(wxCommandEvent &event)
{
    Close();
}




void Grafiek::signaalKeuzeHandler(wxCommandEvent &event)
{
    const UInt32 keuze = signaalKeuzeRadioBox->GetSelection();
    
    if ((keuze == 2) || (keuze == 3))
	signaalFreqKeuze->Disable();
    
}


void Grafiek::signaalAmplitudeHandler(wxSpinEvent &event)
{
    amplitude = amplitudeSpin->GetValue();
    
}


void Grafiek::signaalFreqHandler(wxCommandEvent &event)
{
    switch(signaalFreqKeuze->GetSelection())
    {
    case 0: 
	hoekFreq = 0.0;
	break;

    case 1:
	hoekFreq = 0.05*Pi;
	break;

    case 2:
	hoekFreq = 0.1*Pi;
	break;

    case 3:
	hoekFreq = 0.2*Pi;
	break;
    case 4:
	hoekFreq = 0.4*Pi;
	break;
    case 5:
	hoekFreq = 0.6*Pi;
	break;
    case 6:
	hoekFreq = 0.8*Pi;
	break;
    case 7:
	hoekFreq = 0.9*Pi;
	break;

    default:
	break;
    }
    
	
}
// wxGlade: add Grafiek event handlers


void Grafiek::set_properties()
{
    // begin wxGlade: Grafiek::set_properties
    SetTitle(wxT("FIR filter implementatie demo"));
    signaalKeuzeRadioBox->SetSelection(0);
    signaalFreqKeuze->SetSelection(2);
    kopTekstLabel->SetFont(wxFont(16, wxDEFAULT, wxNORMAL, wxNORMAL, 0, wxT("")));
    // end wxGlade

    hoekFreq = 0.1*Pi;
    amplitude = 20000;
    
}


void Grafiek::do_layout()
{
    // begin wxGlade: Grafiek::do_layout
    wxBoxSizer* sizer_1 = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer* sizer_3 = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer* sizer_4 = new wxBoxSizer(wxVERTICAL);
    sizer_4->Add(signaalKeuzeRadioBox, 0, wxALL|wxALIGN_BOTTOM|wxADJUST_MINSIZE, 10);
    sizer_4->Add(amplitudeLabel, 0, wxLEFT|wxRIGHT|wxTOP|wxADJUST_MINSIZE, 10);
    sizer_4->Add(amplitudeSpin, 0, wxLEFT|wxRIGHT|wxBOTTOM|wxADJUST_MINSIZE, 10);
    sizer_4->Add(sigFreqLabel, 0, wxLEFT|wxRIGHT|wxTOP|wxADJUST_MINSIZE, 10);
    sizer_4->Add(signaalFreqKeuze, 0, wxLEFT|wxRIGHT|wxBOTTOM|wxADJUST_MINSIZE, 10);
    sizer_4->Add(startKnop, 0, wxALL|wxALIGN_BOTTOM|wxADJUST_MINSIZE, 20);
    sizer_4->Add(eindeKnop, 0, wxALL|wxALIGN_BOTTOM|wxADJUST_MINSIZE, 20);
    sizer_1->Add(sizer_4, 1, wxADJUST_MINSIZE, 0);
    sizer_3->Add(kopTekstLabel, 0, wxALIGN_CENTER_HORIZONTAL|wxADJUST_MINSIZE, 0);
    sizer_3->Add(grafiekPaneel, 1, wxEXPAND, 0);
    sizer_1->Add(sizer_3, 6, wxEXPAND, 0);
    SetAutoLayout(true);
    SetSizer(sizer_1);
    sizer_1->Fit(this);
    sizer_1->SetSizeHints(this);
    Layout();
    // end wxGlade
}

/****************** filter funkties *******************/
void Grafiek::bouwSignaal()
{
    UInt32 i;

    switch(signaalKeuzeRadioBox->GetSelection())
    {
    case 0:  /* cosinus */          /* signaal  = cos(2*pi*f/fs * i ) = cos( 0 .. pi * i) */
	for (i=0;i<AantalDataPunten;i++)
	    signaal[i] = (Int16)(amplitude*cos(hoekFreq*i));
	break;

    case 1:  /* blokgolf */
	for (i=0;i<AantalDataPunten;i++)
	{
	    if (cos(hoekFreq*i) > 0 )
		signaal[i] = (Int16)amplitude;
	    else
		signaal[i] = (Int16)-1*amplitude;
	}
	
	break;
	
    case 2: /* impuls op 25% van de totale invoer */
	for (i=0;i<AantalDataPunten;i++)
	    signaal[i] = 0;
	
	i = AantalDataPunten/4;
	signaal[i] = amplitude;
	
	break;
	
    case 3:  /* stapfunktie vanaf 25% vanaf begin */
	for (i=0;i<AantalDataPunten/4;i++)
	    signaal[i] = 0;

	for (i=AantalDataPunten/4;i<AantalDataPunten;i++)
	    signaal[i] = amplitude;
	break;
	
    default:
	break;
	
    }
}

void Grafiek::filterSignaal()
{
    static Int16 filterGeheugen[FilterAantalCoefficienten], *geheugenPtr, *hlpPtr;
    static const Int16 *filterGeheugenEinde = &filterGeheugen[FilterAantalCoefficienten];  /* efficient */

    UInt32 i,j;
    register Int32 mac;

    geheugenPtr = filterGeheugen;
    
    /* reset filter geheugen */
    for (j=0;j<FilterAantalCoefficienten;j++)
	*(geheugenPtr+j) = 0;
    
    for (i=0;i<AantalDataPunten;i++)   /* alle samples worden zo bewerkt */
    {
	hlpPtr = geheugenPtr;       /* wijs naar beginpunt in circulaire buffer */
	*geheugenPtr = signaal[i];  /* kopieer nieuwste sample naar circulaire buffer */
	mac = 0;

	/* werk alle coefficienten af */
	for (j=0;j<FilterAantalCoefficienten;j++)
	{
	    mac += filterCoefficienten[j] * (*hlpPtr);  /* Mupltiply Accumulate */
	    if (--hlpPtr == (filterGeheugen-1) )  /* begin vd buffer bereikt */
		hlpPtr = (Int16 *) (filterGeheugenEinde-1);   /* reset naar begin van de buffer */
	}

	/* kopieer mac resultaat naar gefilterd signaal */
	/* zorg ervoor dat extra bits worden verwijderd */

	sigGefilterd[i] = mac >> ((8*sizeof(FilterImplentatieBasis))-1);
	
	/* verschuif het beginpunt van de circulaire buffer */
	if (++geheugenPtr  == filterGeheugenEinde )  /* einde vd buffer bereikt */
	    geheugenPtr =  filterGeheugen;  /* reset naar begin vd buffer */
    }
    
    
    
}


/************* Het tekenveld *******************/


BEGIN_EVENT_TABLE( GrafiekPaneel, wxPanel)

    EVT_PAINT(GrafiekPaneel::teken)

END_EVENT_TABLE();


GrafiekPaneel::GrafiekPaneel(wxWindow* parent, int id, const wxPoint& pos, const wxSize& size, long style):
    wxPanel(parent, id, pos, size, wxTAB_TRAVERSAL)
{
    // begin wxGlade: GrafiekPaneel::GrafiekPaneel

    set_properties();
    do_layout();
    // end wxGlade

    dataGeladen = False;
    

}


void GrafiekPaneel::set_properties()
{
    // begin wxGlade: GrafiekPaneel::set_properties
    SetMinSize(wxSize(512,500));
    SetBackgroundColour(wxColour(255, 251, 223));
    // end wxGlade
}


void GrafiekPaneel::do_layout()
{
    // begin wxGlade: GrafiekPaneel::do_layout
    // end wxGlade
}


FoutCode GrafiekPaneel::kopieerSignaal(const Int16 *sig, const Int16 *filtSig)
{
    UInt32 i;
    
    Int16 *sigPtr = signaal, *filtPtr = gefilterdSignaal;
    
    wxASSERT_MSG(((sig != (Int16 *)Null) && (filtSig != (Int16 *)Null)),
		 wxT("(kopieerSignaal) data is Null pointer."));

    wxASSERT_MSG((AantalDataPunten < 512), wxT("(kopieerSignaal) aantal datapunten groter dan x-as."));
      
    for (i=0;i<AantalDataPunten;i++)
    {
	*(sigPtr++) = *(sig++);
	*(filtPtr++) = *(filtSig++);
    }
    

    dataGeladen = True;
      
    return(Ok);
      
}

    
void GrafiekPaneel::maakSchoon()
{
    wxPaintDC dc(this);
    dc.Clear();
}



    
void GrafiekPaneel::teken(wxPaintEvent &event)
{
  if (!dataGeladen)
    event.Skip();
  else
    {
      wxPaintDC dc(this);

      UInt32 i;
      wxSize grootte;
      wxSize schaal;
      
      wxString xLabel, yLabel,waardeVeld;

      PrepareDC(dc);

      dc.Clear();

      /* bepaal de dimensies van de dc */
      grootte = dc.GetSize();

      /* schaling x bereik naar 1 en van y bereik naar grafiek grootte */
      schaal.Set(grootte.GetWidth()/AantalDataPunten,65536/grootte.GetHeight());


      /* zet het font */
      dc.SetFont( wxFont(10, 
			 wxMODERN, 
			 wxNORMAL,
			 wxNORMAL,
			 False,
			 wxT(""),
			 wxFONTENCODING_SYSTEM ));


      /* zet de oorsprong linksmidden */
      dc.SetDeviceOrigin((wxCoord)0,
			 grootte.GetHeight()/2);

      /* zet het dc assenstelsel zoals wij zelf tekenen */
      dc.SetAxisOrientation(True, True);

      /* teken het assenstelsel */
      dc.SetPen( wxPen(wxT("RED"), 2, wxSOLID));
      dc.DrawLine(0,0,(wxCoord)(-1*grootte.GetHeight()/2),(wxCoord)( grootte.GetHeight()/2));  /* y-as */
      dc.DrawLine(0, 0,(wxCoord)grootte.GetWidth(),0); /* x-as */
       
      /* teken de originele data */
      dc.SetPen( wxPen( wxT("CORNFLOWER BLUE"), 1, wxSOLID));

      for (i=0;i<AantalDataPunten;i++)
	  dc.DrawRectangle((wxCoord)(schaal.GetWidth()*i),0,
		      (wxCoord)(schaal.GetWidth()),(wxCoord)signaal[i]/schaal.GetHeight());

      /* teken de gefilterde data */
      /* Deze is 2 pixels naar rechts geschoven voor zichtbaarheid */
      dc.SetPen( wxPen( wxT("BROWN"), 1, wxSOLID));

      for (i=0;i<AantalDataPunten;i++)
	  dc.DrawRectangle(2+(wxCoord)(schaal.GetWidth()*i),
			   0,
			   (wxCoord)(schaal.GetWidth()),
			   (wxCoord)gefilterdSignaal[i]/schaal.GetHeight());


      
    }
  
}

	      






/******* Hieronder : de applikatie *******/

class FIRFilter: public wxApp {
public:
    bool OnInit();
};

IMPLEMENT_APP(FIRFilter)

bool FIRFilter::OnInit()
{
    wxInitAllImageHandlers();
    Grafiek* venster = new Grafiek(0, -1, wxT(""));
    SetTopWindow(venster);
    venster->Show();
    return true;
}






















