// -*- C++ -*- generated by wxGlade 0.4 on Wed Apr 19 09:12:48 2006

/********************************

(c)2006 E.J Boks, Hogeschool van Arnhem en Nijmegen
Demonstratieprogramma voor FIR implementatie met Matlab filter coefficienten

********************************/ 

#ifndef FIR_H
#define FIR_H

#include <wx/wx.h>
#include <wx/image.h>

// begin wxGlade: ::dependencies
#include <wx/spinctrl.h>
#include <wx/tglbtn.h>
// end wxGlade

#include "algdef.h"


#define AantalDataPunten          128
#define Pi                        3.141592654
#define FilterImplentatieBasis    Int16      	/* Coefficienten in Q15 formaat */



class GrafiekPaneel: public wxPanel {
public:
    // begin wxGlade: GrafiekPaneel::ids
    // end wxGlade

    GrafiekPaneel(wxWindow* parent, int id, const wxPoint& pos=wxDefaultPosition, const wxSize& size=wxDefaultSize, long style=0);
    FoutCode kopieerSignaal(const Int16 *, const Int16 *);
    void maakSchoon();
    
private:
    // begin wxGlade: GrafiekPaneel::methods
    void set_properties();
    void do_layout();
    // end wxGlade


    
    Int16 signaal[AantalDataPunten], gefilterdSignaal[AantalDataPunten];
    Bool8 dataGeladen;
    
protected:
    // begin wxGlade: GrafiekPaneel::attributes
    // end wxGlade

    void teken(wxPaintEvent &);

    DECLARE_EVENT_TABLE();
    

}; // wxGlade: end class




class Grafiek: public wxFrame {
public:
    // begin wxGlade: Grafiek::ids
    // end wxGlade

    Grafiek(wxWindow* parent, int id, const wxString& title, const wxPoint& pos=wxDefaultPosition, const wxSize& size=wxDefaultSize, long style=wxDEFAULT_FRAME_STYLE);

private:
    // begin wxGlade: Grafiek::methods
    void set_properties();
    void do_layout();
    // end wxGlade

    Int16 signaal[AantalDataPunten], sigGefilterd[AantalDataPunten];
    Float hoekFreq;
    UInt16 amplitude;
    Bool8 start;
    
    void bouwSignaal();
    void filterSignaal();
    
protected:
    // begin wxGlade: Grafiek::attributes
    wxRadioBox* signaalKeuzeRadioBox;
    wxStaticText* amplitudeLabel;
    wxSpinCtrl* amplitudeSpin;
    wxStaticText* sigFreqLabel;
    wxChoice* signaalFreqKeuze;
    wxToggleButton* startKnop;
    wxButton* eindeKnop;
    wxStaticText* kopTekstLabel;
    GrafiekPaneel* grafiekPaneel;
    // end wxGlade

    void startStopHandler(wxCommandEvent &event); // wxGlade: <event_handler>
    void eindeHandler(wxCommandEvent &event); // wxGlade: <event_handler>
    void signaalKeuzeHandler(wxCommandEvent &event); // wxGlade: <event_handler>
    void signaalAmplitudeHandler(wxSpinEvent &event); // wxGlade: <event_handler>
    void signaalFreqHandler(wxCommandEvent &event); // wxGlade: <event_handler>

    void eindeUpdateHandler(wxUpdateUIEvent &);

    DECLARE_EVENT_TABLE();

}; // wxGlade: end class


#endif // FIR_H
